const std = @import("std");

const build_options = @import("build_options");

const Self = @This();

pub const Dimension = i32;
pub const Coordinate = i32;

pub const material_max_len = build_options.material_max_len;
pub const csv_max_len: usize = blk: {
    const str = std.fmt.comptimePrint(
        "-{d},-{d},-{d},-{d},",
        .{
            std.math.maxInt(Dimension),
            std.math.maxInt(Coordinate),
            std.math.maxInt(Coordinate),
            std.math.maxInt(Coordinate),
        },
    );
    break :blk str.len + material_max_len;
};

dimension: Dimension,
x: Coordinate,
y: Coordinate,
z: Coordinate,
material: [material_max_len]u8 = undefined,
material_len: usize = 0,

pub fn toCsv(self: *const Self, buf: *[csv_max_len]u8) ![]u8 {
    return try std.fmt.bufPrint(buf, "{d},{d},{d},{d},{s}", .{
        self.dimension,
        self.x,
        self.y,
        self.z,
        self.material[0..self.material_len],
    });
}
